
namespace norm

-- normal class for other classes to inherit attributes from.

public include append.e
-- {position, data} = faster_append(s, x)

-- Local variables:

sequence data
public integer id -- feature, it can be accessed directly (public)

-- initialize:

data = {}
id = 0

-- Public methods:

public type normal_t(object name)
	return 1
end type

public function size()
	return data[1] -- s[1] is length of s[2]
end function

public function new(object n = {})
	data = faster_append( data, n )
	id = size()
	return id
end function

public function select(integer i)
	id = i
	return id
end function

public function get()
	return data[2][id] -- get data for this id's class
end function

public function set(object val)
	data[2][id] = val -- store this class's data
	return id
end function


public function id_dump()
	return id
end function
public function data_dump()
	return data
end function


public function id_replace(integer i)
	return select( i )
end function
public function data_replace(sequence d)
	data = d
	return data_dump()
end function


public function dump_all()
	return {id_dump(), data_dump()}
end function

