

public function faster_append(sequence s, object x)
-- s[1] is position, s[2] is data
-- use:
-- s = faster_append({},n)
-- then:
-- s[1] is length
-- s[2][s[1]] is last element
-- s[2][1] is first element
-- s = faster_append(s, n2)
-- s = {2, {n, n2, 0, 0, ...}}
-- once s[1] gets to be greater than 100, then it uses eu:append()
	sequence r
	integer p
	if length(s) = 0 then
		r = repeat( 0, 100 ) -- must be 100, Euphoria-specific
		r[1] = x
		return {1,r}
	end if
	p = s[1] + 1
	r = s[2]
	if p < 100 then -- faster for sequences smaller then 100 elements
		r[p] = x
		return {p,r}
	else
		r = eu:append( r, x ) -- Euphoria-specific (allocates 100 at a time)
		return {p,r}
	end if
	
end function


